;
; Create a Window
;
#WinStyle = #PB_Window_SystemMenu | #PB_Window_MinimizeGadget | #PB_Window_MaximizeGadget
hWnd = OpenWindow(0, (GetSystemMetrics_(#SM_CXSCREEN)-210)/2,(GetSystemMetrics_(#SM_CYSCREEN)-300)/2, 210, 330, "Toolbar by Danilo", #WinStyle)
;
; Button Images
;
Image1 = LoadImage(1,"TB.BMP")                  ; Load the Buttons
Image2 = LoadImage(2,"TBMASK.BMP")              ; Load the Mask (for Transparency)
;
; Toolbar 1
CreateTB(1,hWnd,50,39)                            ; Create the Toolbar
SetTBimage(Image1,Image2,#TBpro_NORMAL)         ; Set the 2 Images for the Toolbar
; Add some buttons
    AddTBbutton(101,1,#TBpro_PushBUTTON)                ; 3 standard Buttons
    AddTBbutton(102,2,#TBpro_PushBUTTON)
    AddTBbutton(103,3,#TBpro_PushBUTTON)
;
; Toolbar 2
CreateTB(2,hWnd,50,39)                            ; Create the Toolbar
SetTBimage(Image1,Image2,#TBpro_NORMAL)         ; Set the 2 Images for the Toolbar
; Add some buttons
    AddTBbutton(201,2,#TBpro_BUTTON)                ; 3 standard Buttons
    AddTBbutton(202,3,#TBpro_BUTTON)
    AddTBbutton(203,1,#TBpro_BUTTON)
;
; Toolbar 3
CreateTB(3,hWnd,50,39)                            ; Create the Toolbar
SetTBimage(Image1,Image2,#TBpro_NORMAL)         ; Set the 2 Images for the Toolbar
; Add some buttons
    AddTBbutton(301,3,#TBpro_BUTTON)                ; 3 standard Buttons
    AddTBbutton(302,1,#TBpro_BUTTON)
    AddTBbutton(303,2,#TBpro_BUTTON)
;
; Exit Button
;
  If CreateGadgetList(hWnd)
     ButtonGadget(0, 150, 305, 60, 25, "Quit")
     container1 = ContainerGadget(1,20, 20,TBwidth(1)  ,TBheight(1)-4,#PB_Container_BorderLess):CloseGadgetList()
     container2 = ContainerGadget(2,20,120,TBwidth(2)+2,TBheight(2)-2,#PB_Container_Flat)      :CloseGadgetList()
     container3 = ContainerGadget(3,20,220,TBwidth(3)+2,TBheight(3)-2,#PB_Container_Single)    :CloseGadgetList()
  EndIf

SetTBparent(1,container1)  ; Move all 3 Toolbars
SetTBparent(2,container2)  ; into 3 different
SetTBparent(3,container3)  ; ContainerGadgets

; Set the Backgroundcolor for the Panels
SetWinBackgroundColor(container1,RGB($FF,$AA,$00))
SetWinBackgroundColor(container2,RGB($FF,$AA,$80))
SetWinBackgroundColor(container3,RGB($AA,$AA,$AA))
;
; Main Loop
;
  Repeat
         Select WaitWindowEvent()
            Case #PB_Event_Gadget
                 Select EventGadget()
                   Case 0               ; EXIT
                        End
                 EndSelect
            Case #PB_Event_Menu
                 MessageRequester("INFO","MenuID: "+Str(EventMenu()))
                 
            ; pressed CloseButton or ALT+F4 ??
            Case #PB_Event_CloseWindow
                 End
         EndSelect
  ForEver 