EnableExplicit

Define.s Path, Pack, File
Define.l Count, I

Pack = ProgramFilename()
Count = DBin_TotalFiles(Pack)

If Count
  Path =  PathRequester("Select folder to extract", GetTemporaryDirectory())
  If Path
    If Count
      For I = 0 To Count -1
        File = DBin_Dir(Pack, I)
        MakeSureDirectoryPathExists_(Path + GetPathPart(File))
        DBin_SaveFile(Pack, File, Path + File, "")
      Next
    EndIf
  EndIf
EndIf