
Procedure DBin_LinkToExe(DBinFile.s, ExeFile.s)
  Protected File.l, Pack.l, Size.l, Mem.l
  File = OpenFile(#PB_Any, ExeFile)
  If File
    Pack = ReadFile(#PB_Any, DBinFile)
    Size = Lof(Pack)
    Mem = AllocateMemory(Size)
    If Mem
      ReadData(Pack, Mem, Size)
      CloseFile(Pack)
      FileSeek(File, Lof(File))
      WriteData(File, Mem, Size)
      CloseFile(File)
      FreeMemory(Mem)
      ProcedureReturn #True
    EndIf
  EndIf
  ProcedureReturn #False
EndProcedure

;DBin_LinkToExe("MyBin", "DBin_simple..exe")
DBin_LinkToExe("test.bin", "logo.exe")
